--- old/usr/src/uts/common/fs/zfs/dsl_destroy.c	2013-05-29 20:27:08.983124470 +0000
+++ new/usr/src/uts/common/fs/zfs/dsl_destroy.c	2013-05-29 20:27:08.988935270 +0000
@@ -21,6 +21,7 @@
 /*
  * Copyright (c) 2005, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright (c) 2013 by Delphix. All rights reserved.
+ * Copyright (c) 2013 Steven Hartland. All rights reserved.
  */
 
 #include <sys/zfs_context.h>
@@ -127,6 +128,10 @@
 	pair = nvlist_next_nvpair(dsda->dsda_errlist, NULL);
 	if (pair != NULL)
 		return (fnvpair_value_int32(pair));
+
+	if (nvlist_next_nvpair(dsda->dsda_successful_snaps, NULL) == NULL)
+		return (ENOENT);
+
 	return (0);
 }
 
